searchNodes=[{"ref":"Skogsra.html","title":"Skogsra","type":"module","doc":"This module defines the macros needed to use Skogsra e.g: defmodule MyApp.Settings do use Skogsra @envdoc &quot;My hostname&quot; app_env :my_hostname, :myapp, :hostname, default: &quot;localhost&quot; end"},{"ref":"Skogsra.html#__using__/1","title":"Skogsra.__using__/1","type":"macro","doc":"For now is just equivalent to use import Skogsra."},{"ref":"Skogsra.html#app_env/4","title":"Skogsra.app_env/4","type":"macro","doc":"Creates a function to retrieve specific environment/application variables values. The function created is named function_name and will get the value associated with an application called app_name and one or several parameters keys. Optionally, receives a list of options. Options: default - Default value for the variable in case is not present. type - Type of the variable. Used for casting the value. By default, casts the value to the same type of the default value. If the default value is not present, defaults to :binary. The available values are: :binary, :integer, :float, :boolean, :atom. Additionally, you can provide {module, function} for custom types. The function must receive the binary and return the custom type. os_env - Alias for the variable in the OS. If the alias is nil will use the default name. This option is ignored if the option skip_system is true (default is false). namespace - Namespace of the variable. skip_system - If true, doesn&#39;t look for the variable value in the system. Defaults to false. skip_config - If true, doesn&#39;t look for the variable value in the configuration. Defaults to false. required - Errors when the value is nil. Defaults to false. cached - Caches the value on the first read. Defaults to true. e.g: For the following declaration: app_env :db_password, :myapp, [:mydb, :password], default: &quot;password&quot;, will generate: db_password/0 and db_password/1 for getting the variable&#39;s value without or with namespace respectively. It returns :ok and :error tuples. db_password!/0 and db_password!/1 for getting the variable&#39;s value without or with namespace respectively. It fails on error. reload_db_password/0 and reload_db_password/1 for reloading the variable&#39;s value in the cache without or with namespace respectively. put_db_password/1 and put_db_password/2 for settings a new value for the variable directly to the cache without or with namespace respectively. A call to db_password/0 will try to: Look for the value of $MYAPP_MYDB_PASSWORD OS environment variable. If it&#39;s nil, then it will try 2. Look for the value in the configuration e.g: config :myapp, mydb: [password: &quot;some password&quot;] If it&#39;s nil, then it will try 3. Return the value of the default value or nil. A call to db_password/1 with namespace Test will try to: Look for the value of $TEST_MYAPP_MYDB_PASSWORD OS environment variable. If it&#39;s nil, then it will try 2. Look for the value in the configuration e.g: config :myapp, Test, mydb: [password: &quot;some password&quot;] If it&#39;s nil, then it will try 3. Return the value of the default value or nil."},{"ref":"Skogsra.Settings.html","title":"Skogsra.Settings","type":"module","doc":"Settings for Skogsra (only testing purposes)."},{"ref":"Skogsra.Settings.html#application_module/1","title":"Skogsra.Settings.application_module/1","type":"function","doc":"Changes Application for a custom module (only for testing purposes). A call to Skogsra.Settings.application_module(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Skogsra.Settings.application_module(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $SKOGSRA_APPLICATION_MODULE. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_SKOGSRA_APPLICATION_MODULE. The expected application configuration would be as follows: Without namespace: config :skogsra, application_module: :atom() # Defaults to Application With namespace e.g. My.Custom.Namespace: config :skogsra, My.Custom.Namespace, application_module: :atom() # Defaults to Application"},{"ref":"Skogsra.Settings.html#application_module!/1","title":"Skogsra.Settings.application_module!/1","type":"function","doc":"Changes Application for a custom module (only for testing purposes). Bang version of Skogsra.Settings.application_module/0 (fails on error)."},{"ref":"Skogsra.Settings.html#put_application_module/2","title":"Skogsra.Settings.put_application_module/2","type":"function","doc":"Puts the value to Skogsra.Settings.application_module/0. Optionally, receives the namespace."},{"ref":"Skogsra.Settings.html#put_system_module/2","title":"Skogsra.Settings.put_system_module/2","type":"function","doc":"Puts the value to Skogsra.Settings.system_module/0. Optionally, receives the namespace."},{"ref":"Skogsra.Settings.html#reload_application_module/1","title":"Skogsra.Settings.reload_application_module/1","type":"function","doc":"Reloads the value for Skogsra.Settings.application_module/0. Optionally, receives the namespace for the variable."},{"ref":"Skogsra.Settings.html#reload_system_module/1","title":"Skogsra.Settings.reload_system_module/1","type":"function","doc":"Reloads the value for Skogsra.Settings.system_module/0. Optionally, receives the namespace for the variable."},{"ref":"Skogsra.Settings.html#system_module/1","title":"Skogsra.Settings.system_module/1","type":"function","doc":"Changes System for a custom module (only for testing purposes). A call to Skogsra.Settings.system_module(): When the OS environment variable is not nil, then it&#39;ll return its casted value. When the OS environment variable is nil, then it&#39;ll try to get the value from the configuration file. When the configuration file does not contain the variable, then it&#39;ll return the default value if it&#39;s defined. When the default value is not defined and it&#39;s not required, it&#39;ll return nil, otherwise it&#39;ll return an error. A call to Skogsra.Settings.system_module(namespace) will try to do the same as before, but with a namespace (atom()). This is useful for spliting different configurations values for the same variable e.g. different environments. The OS environment variables expected are: When no namespace is specified, then it&#39;ll be $SKOGSRA_SYSTEM_MODULE. When a namespace is specified e.g. My.Custom.Namespace, then it&#39;ll be $MY_CUSTOM_NAMESPACE_SKOGSRA_SYSTEM_MODULE. The expected application configuration would be as follows: Without namespace: config :skogsra, system_module: :atom() # Defaults to System With namespace e.g. My.Custom.Namespace: config :skogsra, My.Custom.Namespace, system_module: :atom() # Defaults to System"},{"ref":"Skogsra.Settings.html#system_module!/1","title":"Skogsra.Settings.system_module!/1","type":"function","doc":"Changes System for a custom module (only for testing purposes). Bang version of Skogsra.Settings.system_module/0 (fails on error)."},{"ref":"Skogsra.Core.html","title":"Skogsra.Core","type":"module","doc":"This module defines the core API for Skogsra."},{"ref":"Skogsra.Core.html#get_env/1","title":"Skogsra.Core.get_env/1","type":"function","doc":"Gets the value of a given env."},{"ref":"Skogsra.Core.html#get_env!/1","title":"Skogsra.Core.get_env!/1","type":"function","doc":"Gets the value of a given env. Fails on error."},{"ref":"Skogsra.Core.html#put_env/2","title":"Skogsra.Core.put_env/2","type":"function","doc":"Puts a new value for an env."},{"ref":"Skogsra.Core.html#reload_env/1","title":"Skogsra.Core.reload_env/1","type":"function","doc":"Reloads an env variable."},{"ref":"Skogsra.Env.html","title":"Skogsra.Env","type":"module","doc":"This module defines a Skogsra environment variable."},{"ref":"Skogsra.Env.html#__struct__/0","title":"Skogsra.Env.__struct__/0","type":"function","doc":"Environment variable struct."},{"ref":"Skogsra.Env.html#cached?/1","title":"Skogsra.Env.cached?/1","type":"function","doc":"Whether the Skogsra environment variable is cached or not."},{"ref":"Skogsra.Env.html#default/1","title":"Skogsra.Env.default/1","type":"function","doc":"Gets the default value for a Skogsra environment variable."},{"ref":"Skogsra.Env.html#new/4","title":"Skogsra.Env.new/4","type":"function","doc":"Creates a new Skogsra environment variable."},{"ref":"Skogsra.Env.html#os_env/1","title":"Skogsra.Env.os_env/1","type":"function","doc":"Gets the OS variable name for the Skogsra environment variable."},{"ref":"Skogsra.Env.html#required?/1","title":"Skogsra.Env.required?/1","type":"function","doc":"Whether the Skogsra environment variable is required or not."},{"ref":"Skogsra.Env.html#skip_config?/1","title":"Skogsra.Env.skip_config?/1","type":"function","doc":"Whether the Skogsra environment variable should skip config or not."},{"ref":"Skogsra.Env.html#skip_system?/1","title":"Skogsra.Env.skip_system?/1","type":"function","doc":"Whether the Skogsra environment variable should skip system or not."},{"ref":"Skogsra.Env.html#type/1","title":"Skogsra.Env.type/1","type":"function","doc":"Gets the type of the Skogsra environment variable."},{"ref":"Skogsra.Env.html#t:app_name/0","title":"Skogsra.Env.app_name/0","type":"type","doc":"Application name."},{"ref":"Skogsra.Env.html#t:key/0","title":"Skogsra.Env.key/0","type":"type","doc":"Key."},{"ref":"Skogsra.Env.html#t:keys/0","title":"Skogsra.Env.keys/0","type":"type","doc":"List of keys that lead to the value of the variable."},{"ref":"Skogsra.Env.html#t:namespace/0","title":"Skogsra.Env.namespace/0","type":"type","doc":"Variable namespace."},{"ref":"Skogsra.Env.html#t:option/0","title":"Skogsra.Env.option/0","type":"type","doc":"Environment variable options. skip_system - Skips loading the variable from the OS. skip_config - Skips loading the variable from the config. os_env - The name of the OS environment variable. type - Type to cast the OS environment variable value. namespace - Default namespace for the variable. default - Default value. required - Whether the variable is required or not. cached - Whether the variable is cached or not."},{"ref":"Skogsra.Env.html#t:options/0","title":"Skogsra.Env.options/0","type":"type","doc":"Environment variable options:"},{"ref":"Skogsra.Env.html#t:t/0","title":"Skogsra.Env.t/0","type":"type","doc":"Skogsra environment variable."},{"ref":"Skogsra.Env.html#t:type/0","title":"Skogsra.Env.type/0","type":"type","doc":"Types."},{"ref":"Skogsra.App.html","title":"Skogsra.App","type":"module","doc":"This module defines the functions to get variables from the configuration."},{"ref":"Skogsra.App.html#get_env/1","title":"Skogsra.App.get_env/1","type":"function","doc":"Gets config variable value given a Skogsra.Env struct."},{"ref":"Skogsra.Cache.html","title":"Skogsra.Cache","type":"module","doc":"This module defines the helpers for the variable cache. The cache works with persistent terms."},{"ref":"Skogsra.Cache.html#get_env/1","title":"Skogsra.Cache.get_env/1","type":"function","doc":"Gets a variable value env from the cache."},{"ref":"Skogsra.Cache.html#put_env/2","title":"Skogsra.Cache.put_env/2","type":"function","doc":"Stores a variable env in a persistent term."},{"ref":"Skogsra.Sys.html","title":"Skogsra.Sys","type":"module","doc":"This module defines the functions to get environment variables from the OS."},{"ref":"Skogsra.Sys.html#get_env/1","title":"Skogsra.Sys.get_env/1","type":"function","doc":"Gets a OS environment variable value given a Skogsra.Env struct."},{"ref":"Skogsra.Type.html","title":"Skogsra.Type","type":"behaviour","doc":"This module defines the functions and behaviours for casting Skogsra types."},{"ref":"Skogsra.Type.html#__using__/1","title":"Skogsra.Type.__using__/1","type":"macro","doc":"Uses Skogsra.Type for implementing the behaviour e.g. a naive implementation for casting &quot;1, 2, 3, 4&quot; to [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;] would be: defmodule MyList do use Skogsra.Type def cast(value) when is_binary(value) do list = value |&gt; String.split(~r/,/) |&gt; Enum.map(&amp;String.trim/1) {:ok, list} end def cast(_) do :error end end"},{"ref":"Skogsra.Type.html#c:cast/1","title":"Skogsra.Type.cast/1","type":"callback","doc":"Callback for casting a value."},{"ref":"Skogsra.Type.html#cast/2","title":"Skogsra.Type.cast/2","type":"function","doc":"Casts an environment variable."},{"ref":"Skogsra.Docs.html","title":"Skogsra.Docs","type":"module","doc":"This module defines the documentation generators."},{"ref":"Skogsra.Docs.html#gen_full_docs/6","title":"Skogsra.Docs.gen_full_docs/6","type":"function","doc":"Generates docs for a variable given its module, function_name, app_name, keys to find it, options and custom docs."},{"ref":"Skogsra.Docs.html#gen_put_docs/2","title":"Skogsra.Docs.gen_put_docs/2","type":"function","doc":"Generates put docs for a variable given its module and function_name."},{"ref":"Skogsra.Docs.html#gen_reload_docs/2","title":"Skogsra.Docs.gen_reload_docs/2","type":"function","doc":"Generates reload docs for a variable given its module and function_name."},{"ref":"Skogsra.Docs.html#gen_short_docs/3","title":"Skogsra.Docs.gen_short_docs/3","type":"function","doc":"Generates short docs for a variable given its module, function_name, and custom docs."},{"ref":"Skogsra.Docs.html#t:docs/0","title":"Skogsra.Docs.docs/0","type":"type","doc":"Custom docs."},{"ref":"Skogsra.Docs.html#t:function_name/0","title":"Skogsra.Docs.function_name/0","type":"type","doc":"Function name."},{"ref":"Skogsra.Provider.Yaml.html","title":"Skogsra.Provider.Yaml","type":"module","doc":"This module defines a YAML config provider for Skogsra. Important: You need to add {:yamerl, &quot;~&gt; 0.7&quot;} as a dependency along with Skogsra because the dependency is optional. The following is an example for Ecto configuration: # file: /etc/my_app/config.yml - app: &quot;my_app&quot; module: &quot;MyApp.Repo&quot; config: - database: &quot;my_app_db&quot; username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 Then in your release configuration you can add the following: config_providers: [{Skogsra.Provider.Yaml, [&quot;/etc/my_app/config.yml&quot;]}] Once the system boots, it&#39;ll parse and add the YAML configuration."},{"ref":"Skogsra.Provider.Yaml.html#t:key/0","title":"Skogsra.Provider.Yaml.key/0","type":"type","doc":""},{"ref":"readme.html","title":"Skogsrå","type":"extras","doc":"Skogsrå The Skogsrå was a mythical creature of the forest that appears in the form of a small, beautiful woman with a seemingly friendly temperament. However, those who are enticed into following her into the forest are never seen again. This library attempts to improve the use of OS environment variables for application configuration: Automatic type casting of values. Variable defaults. Automatic documentation generation for variables. Runtime reloading. Setting variable&#39;s values at runtime. Fast cached values access by using :persistent_term as temporal storage. YAML configuration provider for Elixir releases."},{"ref":"readme.html#small-example","title":"Skogsrå - Small Example","type":"extras","doc":"You would create a settings module e.g: defmodule MyApp.Settings do use Skogsra @envdoc &quot;My hostname&quot; app_env :my_hostname, :myapp, :hostname, default: &quot;localhost&quot; end Calling MyApp.Settings.my_hostname() will retrieve the value for the hostname in the following order: From the OS environment variable $MYAPP_HOSTNAME. From the configuration file e.g: config :myapp, hostname: &quot;my.custom.host&quot; From the default value if it exists (In this case, it would return &quot;localhost&quot;)."},{"ref":"readme.html#handling-different-environments","title":"Skogsrå - Handling different environments","type":"extras","doc":"If it&#39;s necessary to keep several environments, it&#39;s possible to use a namespace e.g: Calling MyApp.Settings.my_hostname(Test) will retrieve the value for the hostname in the following order: From the OS environment variable $TEST_MYAPP_HOSTNAME. From the configuration file e.g: config :myapp, Test, hostname: &quot;my.custom.test.host&quot; From the OS environment variable $MYAPP_HOSTNAME. From the configuraton file e.g: config :myapp, hostname: &quot;my.custom.host&quot; From the default value if it exists."},{"ref":"readme.html#required-variables","title":"Skogsrå - Required variables","type":"extras","doc":"It is possible to set a environment variable as required with the required option e.g: defmodule MyApp.Settings do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, required: true end If the variable $MYAPP_PORT is undefined and the configuration is missing, calling to MyApp.Settings.my_port() will return an error tuple. Calling $MyApp.Settings.my_port!() (with the bang) will raise a runtime exception."},{"ref":"readme.html#automatic-casting","title":"Skogsrå - Automatic casting","type":"extras","doc":"If the default value is set, the variable value will be casted as the same type of the default value. Otherwise, it is possible to set the type for the variable with the option type. The available types are: :binary (default). :integer. :float. :boolean. :atom. :module (modules loaded in the system). :unsafe_module (modules that might or might not be loaded in the system) Note: :module and :unsafe_module types cannot be derived from the default value type, so they need to be explicitly specified. Additionally, you can create a Skogsra.Type e.g. a naive implementation for casting &quot;1, 2, 3, 4&quot; to [1, 2, 3, 4] would be: defmodule MyList do use Skogsra.Type def cast(value) when is_binary(value) do list = value |&gt; String.split(~r/,/) |&gt; Stream.map(&amp;String.trim/1) |&gt; Enum.map(String.to_integer/1) {:ok, list} end def cast(_) do :error end end If then we define the following enviroment variable with Skogsra: defmodule Settings do use Skogsra app_env :my_integers, :myapp, :my_integers, type: MyList end We can then set $MYAPP_INTEGERS&#39;s value as &quot;1, 2, 3&quot; and it&#39;ll be casted casted to [1, 2, 3] when we call Settings.my_integers/1 function e.g: iex&gt; Settings.my_integers() {:ok, [1, 2, 3]}"},{"ref":"readme.html#setting-and-reloading-variables","title":"Skogsrå - Setting and reloading variables","type":"extras","doc":"It&#39;s possible to set a value for the variable at runtime with e.g. MyApp.Settings.put_my_hostname(&quot;my.other.hostname&quot;). Also, for debugging purposes is possible to reload variables at runtime with e.g. MyApp.Settings.reload_my_hostname()."},{"ref":"readme.html#using-with-hab","title":"Skogsrå - Using with Hab","type":"extras","doc":"Hab is an Oh My ZSH plugin for loading OS environment variables automatically. By default, Hab will try to load .envrc file, but it&#39;s possible to have several of those files for different purposes e.g: .envrc.prod for production OS variables. .envrc.test for testing OS variables. .envrc for development variables. Hab will load the development variables by default, but it can load the other files using the command hab_load &lt;extension&gt; e.g. loading .envrc.prod would be as follows: ~/my_project $ hab_load prod [SUCCESS] Loaded hab [/home/user/my_project/.envrc.prod]"},{"ref":"readme.html#yaml-config-provider","title":"Skogsrå - YAML Config Provider","type":"extras","doc":"Skogsra includes a simple YAML configuration provider compatible with mix release for Elixir ≥ 1.9. The following is the supported configuration format: # file: /etc/my_app/config.yml - app: &quot;my_app&quot; # Name of the application. module: &quot;MyApp.Repo&quot; # Optional module/namespace. config: # Actual configuration. - database: &quot;my_app_db&quot; username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 The previous configuration file would translate to: config :my_app, MyApp.Repo, database: &quot;my_App_db&quot;, username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 For using this config provider, just add the following to your release configuration: config_providers: [{Skogsra.Provider.Yaml, [&quot;/path/to/config/file.yml&quot;]}] Note: If the module you&#39;re using in you&#39;re config does not exist, then change it to namespace e.g: namespace: &quot;MyApp.Repo&quot;. Otherwise, it will fail loading it."},{"ref":"readme.html#installation","title":"Skogsrå - Installation","type":"extras","doc":"The package can be installed by adding skogsra to your list of dependencies in mix.exs. For Elixir ≥ 1.8 and Erlang ≥ 22 def deps do [{:skogsra, &quot;~&gt; 2.0&quot;}] end For Elixir ≥ 1.9, Erlang ≥ 22 and YAML config provider support: def deps do [ {:skogsra, &quot;~&gt; 2.0&quot;}, {:yamerl, &quot;~&gt; 0.7&quot;} ] end"},{"ref":"readme.html#author","title":"Skogsrå - Author","type":"extras","doc":"Alexander de Sousa."},{"ref":"readme.html#license","title":"Skogsrå - License","type":"extras","doc":"Skogsrå is released under the MIT License. See the LICENSE file for further details."},{"ref":"changelog.html","title":"Changelog for 2.0.2","type":"extras","doc":"Changelog for 2.0.2"},{"ref":"changelog.html#enhancements","title":"Changelog for 2.0.2 - Enhancements","type":"extras","doc":"Added :module built-in type. Added :unsafe_module built-in type. Changelog for 2.0.0"},{"ref":"changelog.html#enhancements","title":"Changelog for 2.0.2 - Enhancements","type":"extras","doc":"Added Skogsra.Type behaviour for defining custom types. Application configuration values are now casted as well to the defined type in the Skogsra environment variable definition. Added YAML configuration provider. Changelog for 1.3.0"},{"ref":"changelog.html#enhancements","title":"Changelog for 2.0.2 - Enhancements","type":"extras","doc":"Namespaces now inherit values from default namespace. Favoring the use of :persistent_terms over :ets tables. This avoids the creation of an application tree for this project, thus making it even faster. Changelog for 1.2.1"},{"ref":"changelog.html#bug-fixes","title":"Changelog for 2.0.2 - Bug fixes","type":"extras","doc":"Fix bug where Skogsra.Cache didn&#39;t work at compilation time. Changelog for 1.2.0"},{"ref":"changelog.html#enhancements","title":"Changelog for 2.0.2 - Enhancements","type":"extras","doc":"Added autogenerated reload functions. Added autogenerated setter functions. Improved documentation. Code rearrangement and refactor for maintainability."}]